#include-once

Func _Smooth(ByRef $aP, $iS = 1)
	Local $iI = $aP[0][0]
	For $s = 1 To $iS
		$aP[1][0] = _B($aP[$iI][0], $aP[1][0], $aP[2][0], $aP[3][0])
		$aP[1][1] = _B($aP[$iI][1], $aP[1][1], $aP[2][1], $aP[3][1])
		For $i = 2 To $iI - 2
			$aP[$i][0] = _B($aP[$i - 1][0], $aP[$i][0], $aP[$i + 1][0], $aP[$i + 2][0])
			$aP[$i][1] = _B($aP[$i - 1][1], $aP[$i][1], $aP[$i + 1][1], $aP[$i + 2][1])
		Next
		$aP[$iI - 1][0] = _B($aP[$iI - 2][0], $aP[$iI - 1][0], $aP[$iI][0], $aP[1][0])
		$aP[$iI - 1][1] = _B($aP[$iI - 2][1], $aP[$iI - 1][1], $aP[$iI][1], $aP[1][1])
		$aP[$iI][0] = _B($aP[$iI - 1][0], $aP[$iI][0], $aP[1][0], $aP[2][0])
		$aP[$iI][1] = _B($aP[$iI - 1][1], $aP[$iI][1], $aP[1][1], $aP[2][1])
	Next
EndFunc   ;==>_Smooth

Func _B($1, $2, $3, $4, $t = 0.5)
	Local $V1, $V2, $V3, $V4
	$V1 = (-$1 + 3 * $2 - 3 * $3 + $4) / 6.0
	$V2 = (3 * $1 - 6 * $2 + 3 * $3) / 6.0
	$V3 = (-3 * $1 + 3 * $3) / 6.0
	$V4 = ($1 + 4 * $2 + $3) / 6.0
	Return ($V3 + $t * ($V2 + $t * $V1)) * $t + $V4
EndFunc   ;==>_B