#Include "windows.bi"

Function SmoothPoint(ByVal P1 As Single, ByVal P2 As Single, ByVal P3 As Single, ByVal P4 As Single, ByVal t As Single) As Single
	Dim V1 As Single
	Dim V2 As Single
	Dim V3 As Single
	Dim V4 As Single
	V1 = (-P1 + 3 * P2 - 3 * P3 + P4) / 6.0
	V2 = (3 * P1 - 6 * P2 + 3 * P3) / 6.0
	V3 = (-3 * P1 + 3 * P3) / 6.0
	V4 = (P1 + 4 * P2 + P3) / 6.0
	Return (V3 + t * (V2 + t * V1)) * t + V4
End Function

Extern "Windows-MS"
Function Smooth(BYVAL aPnt As SINGLE Ptr, ByVal iPoints As DWord, ByVal iSteps As DWord)As DWord Export
	Dim iStep As DWord
	Dim iMax As DWord
	Dim iLoop As DWord
	iMax = (iPoints - 1) * 2
	For iStep = 1 To iSteps
		aPnt[0] = SmoothPoint(aPnt[iMax], aPnt[0], aPnt[2], aPnt[4], 0.5)
		aPnt[1] = SmoothPoint(aPnt[iMax+1], aPnt[1], aPnt[3], aPnt[5], 0.5)
		For iLoop = 2 To iMax - 4 Step 2
			aPnt[iLoop] = SmoothPoint(aPnt[iLoop-2], aPnt[iLoop], aPnt[iLoop + 2], aPnt[iLoop + 4], 0.5)
			aPnt[iLoop+1] = SmoothPoint(aPnt[iLoop-1], aPnt[iLoop+1], aPnt[iLoop + 3], aPnt[iLoop + 5], 0.5)
		Next
		aPnt[iMax-2] = SmoothPoint(aPnt[iMax-4], aPnt[iMax-2], aPnt[iMax], aPnt[0], 0.5)
		aPnt[iMax-1] = SmoothPoint(aPnt[iMax-3], aPnt[iMax-1], aPnt[iMax+1], aPnt[1], 0.5)
		aPnt[iMax] = SmoothPoint(aPnt[iMax-2], aPnt[iMax], aPnt[0], aPnt[2], 0.5)
		aPnt[iMax+1] = SmoothPoint(aPnt[iMax-1], aPnt[iMax+1], aPnt[1], aPnt[3], 0.5)
	Next
	Return 1
End Function
End Extern